init:
    
    $ config.debug = True
    $ config.screen_width = 800
    $ config.screen_height = 600
    $ config.searchpath.append('imagedissolve/test')
    image black = Solid((0,0,0))
    image tree = "edinburgh_064.jpg"
    image shibuya = "shibuya50924_DY18.jpg"  
    image tea = "tea00013.jpg"
    image cubic = "cubic.png"
    image dcubic = "dcubic.png"
    image mcubic = "mcubic.png"
    $ radial = im.Image("ccwradial800x600a1.png")
    $ sweep = im.Tile("vblindslr800.png")
        
    python:
        from os import listdir, getcwd
        from glob import glob
        tlist = listdir('imagedissolve/test/')  # filename list
        ti = [] # image list
        for timage in tlist:
            ti.append(im.Tile(timage))

label start:
    scene black
    menu demo:
        "Which demo?"
        "Show controlimages test files":
            jump ctrlimtest
        "Show ramp comparisons":
            jump showcomparisons
            
label ctrlimtest:
    scene black
    menu tdissolvetime:
        "ImageDissolve total time?"
        "Half a second":
            $ dtime = 0.5
        "One second":
            $ dtime = 1.0
        "Two seconds":
            $ dtime = 2.0
        "Three seconds":
            $ dtime = 3.0
        "Four seconds":
            $ dtime = 4.0
    menu tramplen:
        "Size of alpha ramp?"
        "1 (linear only)":
            $ aramp = 1
        "2 (linear only)":
            $ aramp = 2
        "4 (linear only)":
            $ aramp = 4
        "5 (linear only)":
            $ aramp = 5
        "8":
            $ aramp = 8
        "9":
            $ aramp = 9
        "16":
            $ aramp = 16
        "20":
            $ aramp = 20
        "32":
            $ aramp = 32
        "64":
            $ aramp = 64
        "128":
            $ aramp = 128
        "256":
            $ aramp = 256
        "800":
            $ aramp = 800
    
    menu tramptype:
        "Ramp type?"
        "Linear":
            $ type = 'linear'
        "Cube":
            $ type = 'cube'
        "DoubleCube (cubic, origin at center point)":
            $ type = 'dcube'
        "HVMirrorCube (cubic mirrored around center point)":
            $ type = 'mcube'
    menu timageset:
        "Image set?"
        "Black and tree":
            $ imset = 'black'
        "Shibuya and tea":
            $ imset = 'shibuya'
    $ didx = 0
    $ size = len(tlist)
    while didx < size:
        $ di = ti[didx]
        $ desc = tlist[didx]
        $ ui.image(di)
        "%(didx)d: %(desc)s forward"
        if imset == 'black':
            scene tree with ImageDissolve(di, dtime, ramplen=aramp, ramptype=type)
            "%(didx)d %(desc)s reverse"
            scene black with ImageDissolve(di, dtime, ramplen=aramp, reverse=True, ramptype=type)
        elif imset == 'shibuya':
            scene shibuya with ImageDissolve(di, dtime, ramplen=aramp, ramptype=type)
            "%(didx)d: %(desc)s reverse"
            scene tea with ImageDissolve(di, dtime, ramplen=aramp, reverse=True, ramptype=type)
        "Next..."
        $ didx += 1
    "That's all, back to the start..."
    jump start
    
label showcomparisons:
    scene black
    "Horizontal full gradient, linear"
    scene tree with ImageDissolve(sweep, 3, ramplen=256)
    scene black with ImageDissolve(sweep, 3, ramplen=256, reverse=True)
    "Horizontal full gradient, cubic (ease in, sharp out)"
    show cubic
    $ renpy.pause()
    hide cubic
    scene tree with ImageDissolve(sweep, 3, ramplen=256, ramptype='cube')
    scene black with ImageDissolve(sweep, 3, ramplen=256, reverse=True, ramptype='cube')
    "Horizontal full gradient, dcube (sharp in, sharp out)"
    show dcubic
    $ renpy.pause()
    hide dcubic
    scene tree with ImageDissolve(sweep, 3, ramplen=256, ramptype='dcube')
    scene black with ImageDissolve(sweep, 3, ramplen=256, reverse=True, ramptype='dcube')
    "Horizontal full gradient, mcube (ease in, ease out)"
    show mcubic
    $ renpy.pause()
    hide mcubic
    scene tree with ImageDissolve(sweep, 3, ramplen=256, ramptype='mcube')
    scene black with ImageDissolve(sweep, 3, ramplen=256, reverse=True, ramptype='mcube')
    
    "Radial gradient, linear"
    scene shibuya with ImageDissolve(radial, 3, ramplen=256)
    scene tea with ImageDissolve(radial, 3, ramplen=256, reverse=True)
    "Radial gradient, cubic (ease in, sharp out)"
    show cubic
    $ renpy.pause()
    hide cubic
    scene shibuya with ImageDissolve(radial, 3, ramplen=256, ramptype='cube')
    scene tea with ImageDissolve(radial, 3, ramplen=256, reverse=True, ramptype='cube')
    "Radial gradient, dcube (sharp in, sharp out)"
    show dcubic
    $ renpy.pause()
    hide dcubic
    scene shibuya with ImageDissolve(radial, 3, ramplen=256, ramptype='dcube')
    scene tea with ImageDissolve(radial, 3, ramplen=256, reverse=True, ramptype='dcube')
    "Radial gradient, mcube (ease in, ease out)"
    show mcubic
    $ renpy.pause()
    hide mcubic
    scene shibuya with ImageDissolve(radial, 3, ramplen=256, ramptype='mcube')
    scene tea with ImageDissolve(radial, 3, ramplen=256, reverse=True, ramptype='mcube')
    "Done"
    jump start
